addpath('C:\Code\Matlab\Master\Spring')
addpath('C:\Code\Matlab\Master\Spring\Results')

%% Get data
name_file_A = 'acid.mat';
name_file_B = 'base.mat';
acid = load(name_file_A, 'VarMem'); 
base = load(name_file_B, 'VarMem');  

time_A = acid.VarMem.time';
data_A = acid.VarMem.acid';
weight_A = acid.VarMem.weight';

time_B = base.VarMem.time';
data_B = base.VarMem.base';
weight_B = base.VarMem.weight';


%% Plot
color = colorHex();

cut = find(time_A <= 295, 1, 'last');

figure(1)
hold on
colororder({'k','k'})
%ylim([50 90])
plot(time_A(cut:end)/60, data_A(cut:end), 'Color', color.b)
xlabel('Time [min]')
ylabel('Acid')
yyaxis right
plot(time_A(cut:end)/60, weight_A(cut:end), 'Color', color.r)
ylabel('Weight [g]')
legend('Acid','Weight', 'Location', 'NorthWest')
annotation('textbox',  [0.29 0.04 0.3 0.2] , 'String', 'f = 0.00533913', 'FitBoxToText','on', 'FontSize', 9,'LineStyle', 'none')
annotation('textbox',  [0.5 0.2 0.3 0.25] , 'String', 'f = 0.00549003', 'FitBoxToText','on', 'FontSize', 9,'LineStyle', 'none')
annotation('textbox',  [0.7 0.43 0.3 0.25] , 'String', 'f = 0.00546451', 'FitBoxToText','on', 'FontSize', 9,'LineStyle', 'none')


title('Acid pump calibration')

figure(2)
hold on
colororder({'k','k'})
plot(time_B/60, data_B, 'Color', color.b)
xlabel('Time [min]')
ylabel('Base')
yyaxis right
plot(time_B/60, weight_B, 'Color', color.r)
ylabel('Weight [g]')
legend('Base','Weight', 'Location', 'NorthWest')
annotation('textbox',  [0.26 0.018 0.3 0.2] , 'String', 'f = 0.00592909', 'FitBoxToText','on', 'FontSize', 9,'LineStyle', 'none')
annotation('textbox',  [0.47 0.15 0.3 0.25] , 'String', 'f = 0.00570313', 'FitBoxToText','on', 'FontSize', 9,'LineStyle', 'none')
annotation('textbox',  [0.72 0.43 0.3 0.25] , 'String', 'f = 0.00578613', 'FitBoxToText','on', 'FontSize', 9,'LineStyle', 'none')
title('Base pump calibration')