function [t, weight_B, Acid_pump, Base_pump]=Calibration_Acid_Base()

da = opcda('localhost', 'Securecell.OpcBridgeServer.DA.1');
connect(da); 
BioReactor = 'A2';
[readGrpA2, writeGrpA2, indexesA2] = findReactorTags(BioReactor, da);
    %[readGrpHPLC,~, indexesHPLC] = findSampleInfo(reactor, da);
data = read(readGrpA2);
VarMem=  [];


Base_pump = [];
Acid_pump = [];
weight_B = [];
t = [];
t = [t, 0];
dt = 5;
i = 1;
% Run x calibration run
while true
    data = read(readGrpA2);
    [Instrument]=GetInstData(data,indexesA2);
    %scaleBefore=Instrument.Balance_D;
    
    % Fout:
    % write(writeGrpA2.Item(indexesA2.setpoints.Feed_Ext_2_Setpoint), {Controller.Volume.Fout2pump});
    % end
    %pause(t)
    weight_B = [weight_B, Instrument.Balance_B2];
    Acid_pump = [Acid_pump, Instrument.Acid_pump];
    Base_pump = [Base_pump, Instrument.Base_pump];
    
    hold on
    plot(t, weight_B, '-b');
    ylabel("g")
    yyaxis right
    plot(t, Acid_pump, '-r');
    ylabel("acid")
    
    legend("Weight","Acid", 'Location', 'best')
    
    VarMem.weight(i) = Instrument.Balance_B2;
    VarMem.acid(i) = Instrument.Acid_pump;
    VarMem.base(i) = Instrument.Base_pump;
    VarMem.time(i) = t(i);
    
    i = i + 1;
    pause(dt)
    t = [t, t(i-1) + dt];

 end
 % Calibration run i finished

% Save calibration data
filepath = 'C:\Matlab\Helene\Results\'
filename = strcat('Calibration_acid_', BioReactor, '.xlsx');
%filebase = strcat('Calibration_acid_', BioReactor, '.mat');
T = table(VarMem.weight', VarMem.acid',VarMem.time');
%T = table(VarMem.weight', VarMem.base',VarMem.time');
writetable(T, strcat(filepath, filename));
save('acid')
%save('base')

% Disconnect server
disconnect(da)
delete(da)


end



function [readGrp, writeGrp, indexes] = findReactorTags(reactor, da)

% Connect to OPC Server 
%da = opcda('localhost', 'Securecell.OpcBridgeServer.DA.1'); 
%connect(da); 
itmIDs = serveritems(da); 


reactorIDs = [];

% Find all values related to the reactor
for i = 1:length(itmIDs)
    str = [char(itmIDs(i)), ' '];   % Convert cell string to char, add space
                                    % for easier parsing (making sure we
                                    % always have 2 characters)
    if length(reactor) == 2
        if str(1:2) == reactor
            reactorIDs = [reactorIDs; itmIDs(i)];
        end                         
    elseif reactor == 'A' || reactor == 'B'
        if str(1) == reactor && str(2) ~= '2'
            reactorIDs = [reactorIDs; itmIDs(i)];
        end
    else
        if str(1) == reactor
            reactorIDs = [reactorIDs; itmIDs(i)];
        end
    end
end



%  {'Numera.Numera.SEQUENCE_1.TimeStampSec_NU'                   }
%     {'Numera.Numera.SEQUENCE_1.TimeStampHour_NU'  

if isempty(reactorIDs)
    error("No tags were found for reactor """+convertCharsToStrings(reactor)+""". Have you inserted a valid reactor name? Use characters and capital letters, like 'A'.")
end

% Additional instrumentation
balances = reactorIDs(contains(reactorIDs, 'Balance'));
buglab = reactorIDs(contains(reactorIDs, 'Buglab'));
HPLC= reactorIDs(contains(reactorIDs,'HPLC'));

% Take the time stamp sf the last sample of Numera to HPLC
HPLC=[HPLC ; 
    {'Numera.Numera.SEQUENCE_1.TimeStampYear_NU'};
    {'Numera.Numera.SEQUENCE_1.TimeStampMonth_NU'};
    {'Numera.Numera.SEQUENCE_1.TimeStampDay_NU'};
    {'Numera.Numera.SEQUENCE_1.TimeStampHour_NU'};
    {'Numera.Numera.SEQUENCE_1.TimeStampMinute_NU'};% 
    {'Numera.Numera.SEQUENCE_1.TimeStampSec_NU'}];


measurements = reactorIDs(contains(reactorIDs, 'Measured Values'));
controlOutputs = reactorIDs(contains(reactorIDs, 'Controller Output'));
setpoints = reactorIDs(contains(reactorIDs, 'Setpoints'));
sysDevice = reactorIDs(contains(reactorIDs, 'System Device.SystemSubDev'));

% Digging out the timers
HPLC = HPLC(2:end);
measurements = measurements(2:end);
controlOutputs = controlOutputs(2:end);
sysDevice = sysDevice(2:end);
setpoints = setpoints(2:end);

% Adding the scales and HPLC to measurements
Balance_A2 = balances(contains(balances, {'Balance A2.Balance Ports.Weight'}));
Balance_B2 = balances(contains(balances, {'Balance B2.Balance Ports.Weight'}));
Balance_C = balances(contains(balances, {'Balance C.Balance Ports.Weight'}));
Balance_D = balances(contains(balances, {'Balance D.Balance Ports.Weight'}));
measurements = [measurements; Balance_A2; Balance_B2;Balance_C;Balance_D; HPLC];

% Adding the buglab to measurements
buglab_measurement = buglab(contains(buglab, {'Result Raw'}));
measurements = [measurements; buglab_measurement];

% Create Read Group 
readGrp = addgroup(da, ['ReadGroup' ,reactor]); 


%% SEQUENCE TWO OF THE HPLC DATA
NUMERA=itmIDs(contains(itmIDs,'Numera.Numera.SEQUENCE_2'));
NUMERA=NUMERA(2:end);

% For HPLC reactor identification of SampleManagmenet 
% important to know from which reactor the file with the barcode was taken
SampleBarcode=itmIDs(contains(itmIDs,'SampleBarcode'));
SampleName=itmIDs(contains(itmIDs,'SampleName'));

% this loop is to secure the name of the reactor is registered only from the
% first field of the list of possible reactors (because the letters D, E, A
% can also be par of the names in ItemID): 
for z=1:length(SampleBarcode)
    
    SBC=SampleName(contains(SampleName{z}(1:2),reactor));
    if not(isempty(SBC))
        SBCidx=z;
    end
end
SampleName=SampleName(SBCidx);
SampleBarcode=SampleBarcode(SBCidx);

% Adding Numera Sequence 2 information
measurements = [measurements; NUMERA;SampleBarcode;SampleName];



% Add Tags 
readID = [measurements; controlOutputs; sysDevice];
itm = additem(readGrp, readID);
writeGrp = addgroup(da, ['WriteGroup', reactor]);
writeID = setpoints;
itm = additem(writeGrp, writeID);

% Making a structure with the indexes of each variable of interest
measurementIndexes = struct;
measurementIndexes.ExitO2 = find(contains(measurements, 'ExitO2'));
measurementIndexes.GasMix = find(contains(measurements, 'GasMix'));
measurementIndexes.OD = find(contains(measurements, 'OD'));
measurementIndexes.Temperature = find(contains(measurements, 'Temperature'));
measurementIndexes.Feed = find(contains(measurements, 'Feed'));
if length(measurementIndexes.Feed) > 1
    measurementIndexes.Feed_Ext_1 = find(contains(measurements, 'Ext_1'));
    measurementIndexes.Feed_Ext_2 = find(contains(measurements, 'Ext_2'));
    measurementIndexes.Feed_Ext_3 = find(contains(measurements, 'Ext_3'));
    measurementIndexes.Feed_Ext_4 = find(contains(measurements, 'Ext_4'));
    measurementIndexes.Feed_Ext_5 = find(contains(measurements, 'Ext_5'));
    % Make a list of only the IDs of "feed" pumps
    feedMeasurements = measurements(measurementIndexes.Feed);
    % Find the only index that is not "Ext"
    measurementIndexes.Feed = measurementIndexes.Feed ...
        (~contains(feedMeasurements, 'Ext'));
end
measurementIndexes.O2Flow = find(contains(measurements, 'O2Flow'));
measurementIndexes.N2Flow = find(contains(measurements, 'N2Flow'));
measurementIndexes.AirFlow = find(contains(measurements, 'AirFlow'));
measurementIndexes.ExitCO2 = find(contains(measurements, 'ExitCO2'));
measurementIndexes.pH = find(contains(measurements, 'Values.pH'));
measurementIndexes.GMFlow = find(contains(measurements, 'GMFlow'));
measurementIndexes.pO2 = find(contains(measurements, 'pO2'));
measurementIndexes.Antifoam = find(contains(measurements, 'Antifoam'));
measurementIndexes.Stirrer = find(contains(measurements, 'Stirrer'));
measurementIndexes.Balance_A2 = find(contains(measurements, 'Balance A2'));
measurementIndexes.Balance_B2 = find(contains(measurements, 'Balance B2'));
measurementIndexes.Balance_C = find(contains(measurements, 'Balance C'));
measurementIndexes.Balance_D = find(contains(measurements, 'Balance D'));


% Add the HPLC information
measurementIndexes.HPLC_gluc= find(contains(measurements,'Measurements_HPLC.Glucose'));
measurementIndexes.HPLC_ara= find(contains(measurements,'Measurements_HPLC.Arabinose'));
measurementIndexes.HPLC_xyl= find(contains(measurements,'Measurements_HPLC.Xylose'));
measurementIndexes.HPLC_man= find(contains(measurements,'Measurements_HPLC.Mannose'));
measurementIndexes.HPLC_year= find(contains(measurements,'TimeStampYear_NU'));
measurementIndexes.HPLC_month= find(contains(measurements,'TimeStampMonth_NU'));
measurementIndexes.HPLC_day= find(contains(measurements,'TimeStampDay_NU'));
measurementIndexes.HPLC_hour= find(contains(measurements,'TimeStampHour_NU'));
measurementIndexes.HPLC_minute= find(contains(measurements,'TimeStampMinute_NU'));
measurementIndexes.HPLC_sec= find(contains(measurements,'TimeStampSec_NU'));

% Add the Buglab
measurementIndexes.Buglab = find(contains(measurements, 'Buglab'));

% Add the Seq 2 from Numera
measurementIndexes.NumeraIndexes.analyzer_number= find(contains(measurements,'ANALYZER_NUMBER'));
measurementIndexes.NumeraIndexes.seq2_start =find(contains(measurements,'SEQ2_START'));
measurementIndexes.NumeraIndexes.seq2_state =find(contains(measurements,'SEQ2_STATE'));
measurementIndexes.NumeraIndexes.sampling_done =find(contains(measurements,'SAMPLING_DONE'));
measurementIndexes.NumeraIndexes.analyzer_transf_type =find(contains(measurements,'ANALYZER_TRANSF_TYPE'));
measurementIndexes.NumeraIndexes.sample_ready= find(contains(measurements,'SAMPLE_READY'));
measurementIndexes.NumeraIndexes.seq2_stop= find(contains(measurements,'SEQ2_STOP'));

measurementIndexes.SampleBarcode=find(contains(measurements,SampleBarcode));
measurementIndexes.SampleName=find(contains(measurements,SampleName));

controlOutputIndexes = struct;
controlOutputIndexes.GMFlow_Output = find(contains(controlOutputs, 'GMFlow_Output')) + length(measurements);
controlOutputIndexes.Stirrer_Output = find(contains(controlOutputs, 'Stirrer_Output')) + length(measurements);
controlOutputIndexes.AirFlow_Output = find(contains(controlOutputs, 'AirFlow_Output')) + length(measurements);
controlOutputIndexes.OD_Output = find(contains(controlOutputs, 'OD_Output')) + length(measurements);
controlOutputIndexes.Temperature_Output = find(contains(controlOutputs, 'Temperature_Output')) + length(measurements);
controlOutputIndexes.GasMix_Output = find(contains(controlOutputs, 'GasMix_Output')) + length(measurements);
controlOutputIndexes.pH_Output = find(contains(controlOutputs, 'pH_Output')) + length(measurements);
controlOutputIndexes.Feed_Output = find(contains(controlOutputs, 'Feed_Output')) + length(measurements);
controlOutputIndexes.pO2_Output = find(contains(controlOutputs, 'pO2_Output')) + length(measurements);
controlOutputIndexes.ExitCO2_Output = find(contains(controlOutputs, 'ExitCO2_Output')) + length(measurements);
controlOutputIndexes.N2Flow_Output = find(contains(controlOutputs, 'N2Flow_Output')) + length(measurements);
controlOutputIndexes.Antifoam_Output = find(contains(controlOutputs, 'Antifoam_Output')) + length(measurements);
controlOutputIndexes.O2Flow_Output = find(contains(controlOutputs, 'O2Flow_Output')) + length(measurements);
controlOutputIndexes.ExitO2_Output = find(contains(controlOutputs, 'ExitO2_Output')) + length(measurements);
controlOutputIndexes.PumpValAcid = find(contains(controlOutputs, 'Pump_Val_Acid')) + length(measurements);
controlOutputIndexes.PumpValBase = find(contains(controlOutputs, 'Pump_Val_Base')) + length(measurements);

systemIndexes = struct;
systemIndexes.StepTime = find(contains(sysDevice, 'StepTime')) + ...
    length(measurements) + length(controlOutputs);
systemIndexes.ProcTime = find(contains(sysDevice, 'ProcTime')) + ...
    length(measurements) + length(controlOutputs);

setpointIndexes = struct;
setpointIndexes.Antifoam_Setpoint = find(contains(setpoints, 'Antifoam_Setpoint'));
setpointIndexes.Temperature_Setpoint = find(contains(setpoints, 'Temperature_Setpoint'));
setpointIndexes.pO2_Setpoint = find(contains(setpoints, 'pO2_Setpoint'));
setpointIndexes.Stirrer_Setpoint = find(contains(setpoints, 'Stirrer_Setpoint'));
setpointIndexes.GMFlow_Setpoint = find(contains(setpoints, 'GMFlow_Setpoint'));
setpointIndexes.O2Flow_Setpoint = find(contains(setpoints, 'O2Flow_Setpoint'));
setpointIndexes.pH_Setpoint = find(contains(setpoints, 'pH_Setpoint'));
setpointIndexes.AirFlow_Setpoint = find(contains(setpoints, 'AirFlow_Setpoint'));
setpointIndexes.N2Flow_Setpoint = find(contains(setpoints, 'N2Flow_Setpoint'));
setpointIndexes.GasMix_Setpoint = find(contains(setpoints, 'GasMix_Setpoint'));
setpointIndexes.Feed_Setpoint = find(contains(setpoints, 'Feed'));

if length(setpointIndexes.Feed_Setpoint) > 1
    setpointIndexes.Feed_Ext_1_Setpoint = find(contains(setpoints, 'Ext_1'));
    setpointIndexes.Feed_Ext_2_Setpoint = find(contains(setpoints, 'Ext_2'));
    setpointIndexes.Feed_Ext_3_Setpoint = find(contains(setpoints, 'Ext_3'));
    setpointIndexes.Feed_Ext_4_Setpoint = find(contains(setpoints, 'Ext_4'));
    setpointIndexes.Feed_Ext_5_Setpoint = find(contains(setpoints, 'Ext_5'));

    % Make a list of only the IDs of "feed" pumps
    feedSetpoints = setpoints(setpointIndexes.Feed_Setpoint);
    
    % Find the only index that is not "Ext"
    setpointIndexes.Feed_Setpoint = setpointIndexes.Feed_Setpoint ...
        (~contains(feedSetpoints, 'Ext'));
end



indexes = struct;
indexes.system = systemIndexes;
indexes.setpoints = setpointIndexes;
indexes.measurements = measurementIndexes;
indexes.controlOutputs = controlOutputIndexes;
end

function [Instrument]=GetInstData(data,indexesA2)
% clk is the clock information taken in the beginning of the expetiments
% here you can add what you want to Instrument struct (as fields)
% Define data for the balances, 
if ~isnan(indexesA2.measurements.Balance_A2)==1
    Instrument.Balance_A2= double(data(indexesA2.measurements.Balance_A2).Value);
    Instrument.Balance_B2= double(data(indexesA2.measurements.Balance_B2).Value);
end

% Read the data of the pumps
Instrument.Pump_1 = double(data(indexesA2.measurements.Feed_Ext_1).Value);
Instrument.Pump_2 = double(data(indexesA2.measurements.Feed_Ext_2).Value); 
% Acid and Base outputs
Instrument.Acid_pump= double(data(indexesA2.controlOutputs.PumpValAcid).Value);
Instrument.Base_pump= double(data(indexesA2.controlOutputs.PumpValBase).Value);
 
end