function [x_Lplus1, P_Lplus1, pkEig] = arrivalCostUpdate_DYCOPS(MHEsys, MHEprops, x, y, u, P, Q, integrator)   
    addpath('C:\Code\Matlab\Casadi\casadi-windows-matlabR2016a-v3.5.5')
    import casadi.*

    x_L = x(:,1);
    xtPlus1 = x(:,2);
    nx = length(x_L);
    ny = length(MHEsys.y);
    u0 = u(1,:);    % CHANGE WITH FOÌN & FOUT?
    params = u0';
    P_L = P^(-1/2);
    W = Q^(-1/2);
    V = MHEsys.V;
    y_L = y(1,:)';
    
    timestep = MHEprops.T/MHEprops.N;
    
    Fk = integrator('x0',x_L,'p',params);
    
%% Finite differences
    
    res = integrator('x0', x_L, 'p', params);
    xf = full(res.xf);
    
    h = 0.0001;
    X_x = zeros(nx,nx);
    for i = 1:nx
        x0h = x_L;
        x0h(i) = x0h(i) + h;
        res = integrator('x0', x0h, 'p', params);
        X_x(:,i) = (full(res.xf)-xf)/h;
    end

    % ASSUMING h() is a selection matrix

    H_x = [1     0     0     0
           0     1     0     0
           0     0     0     1];
    
    
%% Other parameters
    
    x_tilde = xf - X_x*x_L;
    h_tilde = H_x*xf - H_x*x_L;
    
    
%% Make and QR factorize matrix

    W_bar = W;
    
    factorizable_matrix = [P_L, zeros(length(P_L),length(W_bar)); ...
                            -((V)*H_x), zeros(length(V),length(W_bar)); ...
                            -W_bar*X_x, W_bar];
                        
    [Q_matrix, R] = qr(factorizable_matrix);
    
    nx_np = length(P_L);
    R1 = R(1:nx_np,1:nx_np);
    R12 = R(1:nx_np, nx_np+1:2*nx_np);
    R2 = R(nx_np+1:2*nx_np, nx_np+1:2*nx_np);
    
    P_Lplus1 = R2;

     constantsVector = [ -P_L*[x_L]; ...
                        (V)*(y_L - h_tilde); ...
                        -W_bar*[x_tilde]];
                    
    rho = Q_matrix\constantsVector;
    
    rho2 = rho(nx_np+1:nx_np*2);
    
    x_and_p = -R2\rho2;
    
    x_Lplus1 = x_and_p(1:nx);

pkEig = diag(P_Lplus1);
    
end