function F_integrator = makePlantIntegrator_DYCOPS(ODEmodel,OCPprops)
    addpath('C:\Code\Matlab\Casadi\casadi-windows-matlabR2016a-v3.5.5')
    import casadi.*

    x = ODEmodel.x;
    u = ODEmodel.u;
    x_dot = ODEmodel.x_dot;
    
    timeStep = OCPprops.T/OCPprops.N;
    
    % Variable inputs in a single variable
    p = [u];
    
    ode = struct('x',x,'p',p,'ode',x_dot);
    opts = struct('tf',timeStep);
    
    F_integrator = integrator('F','cvodes',ode,opts);
end