addpath('C:\Code\Matlab\Casadi\casadi-windows-matlabR2016a-v3.5.5')
import casadi.*

addpath('C:\Code\Matlab\Master\Spring')
addpath('C:\Code\Matlab\Master\Spring\Results')
addpath('C:\Code\Matlab\Master\Spring\MHE')

% Get system parameters
system = system_param();
q_CO2 = system.q_CO2;
%% Get data
states_R = importdata('states_R.mat');
t = importdata('t_R.mat');

V_1 = states_R(:, 1);
X_1 = states_R(:, 2);
S_1 = states_R(:, 3);
CO2_1 = states_R(:, 4);


V_4 = states_R(:, 4*3 + 1);
X_4 = states_R(:, 4*3 + 2);
S_4 = states_R(:, 4*3 + 3);
CO2_4 = states_R(:, 4*3 + 4);

% Go through data later - plot average on each, want fill between max and
% min values for all - cut at 1e-4 -> above that gives wierd results
[Vmax, V_max_i] =      max(states_R(:,[1 (4*1 + 1) (4*2 + 1) (4*3 + 1)  ]),[], 2); %(4*4 + 1) (4*5 + 1) ]),[], 2); %(4*6 + 1) (4*7 + 1) (4*8 + 1) ]),[], 2); % 2: operate on each row
[Xmax, X_max_i] =      max(states_R(:,[2 (4*1 + 2) (4*2 + 2) (4*3 + 2)  ]),[], 2); %(4*4 + 2) (4*5 + 2) ]),[], 2); %(4*6 + 2) (4*7 + 2) (4*8 + 2) ]),[], 2); 
[Smax, S_max_i] =      max(states_R(:,[3 (4*1 + 3) (4*2 + 3) (4*3 + 3)  ]),[], 2); %(4*4 + 3) (4*5 + 3) ]),[], 2); %(4*6 + 3) (4*7 + 3) (4*8 + 3) ]),[], 2); 
[CO2_max, CO2_max_i] =   max(states_R(:,[4 (4*1 + 4) (4*2 + 4) (4*3 + 4)  ]),[], 2); %(4*4 + 4) (4*5 + 4)]) ,[], 2); %(4*6 + 4) (4*7 + 4) (4*8 + 4)]),[], 2); 

% find min values
[Vmin, V_min_i] =      min(states_R(:,[1 (4*1 + 1) (4*2 + 1) (4*3 + 1)  ]),[], 2); %(4*4 + 1) (4*5 + 1) ]),[], 2); %(4*6 + 1) (4*7 + 1) (4*8 + 1) ]),[], 2); % 2: operate on each row
[Xmin, X_min_i] =      min(states_R(:,[2 (4*1 + 2) (4*2 + 2) (4*3 + 2)  ]),[], 2); %(4*4 + 2) (4*5 + 2) ]),[], 2); %(4*6 + 2) (4*7 + 2) (4*8 + 2) ]),[], 2); 
[Smin, S_min_i] =      min(states_R(:,[3 (4*1 + 3) (4*2 + 3) (4*3 + 3)  ]),[], 2); %(4*4 + 3) (4*5 + 3) ]),[], 2); %(4*6 + 3) (4*7 + 3) (4*8 + 3) ]),[], 2); 
[CO2_min, Co2_min_i] =   min(states_R(:,[4 (4*1 + 4) (4*2 + 4) (4*3 + 4) ]),[], 2); % (4*4 + 4) (4*5 + 4) ]),[], 2); %(4*6 + 4) (4*7 + 4) (4*8 + 4) ]),[], 2); 

% Mean
Vmean =      mean(states_R(:,[1 (4*1 + 1) (4*2 + 1) (4*3 + 1) ]) , 2); %(4*4 + 1) (4*5 + 1) ]) , 2); %(4*6 + 1) (4*7 + 1) (4*8 + 1) ]), 2); % 2: operate on each row
Xmean =      mean(states_R(:,[2 (4*1 + 2) (4*2 + 2) (4*3 + 2) ]) , 2); %(4*4 + 2) (4*5 + 2) ]) , 2); %(4*6 + 2) (4*7 + 2) (4*8 + 2) ]), 2); 
Smean =      mean(states_R(:,[3 (4*1 + 3) (4*2 + 3) (4*3 + 3) ]) , 2); %(4*4 + 3) (4*5 + 3) ]) , 2); %(4*6 + 3) (4*7 + 3) (4*8 + 3) ]), 2); 
CO2_mean =   mean(states_R(:,[4 (4*1 + 4) (4*2 + 4) (4*3 + 4) ]) , 2); %(4*4 + 4) (4*5 + 4) ]) , 2); %(4*6 + 4) (4*7 + 4) (4*8 + 4) ]), 2); 

%% Get data

%% Sugar
filename_S = 'A2_sugar_20230403_HPLC.xlsx'; %% UPDATE WITH CORRECT FILE

sugar_table = readtable(filename_S, 'Sheet','Corrected_sugar');
sugar_results = table2array(sugar_table(:,2:3)); 

S0_MHE = sugar_results(1,2);

time_s = sugar_results(2:end,1);
sugar = sugar_results(2:end,2);



%% Offline CDW
filename = 'Result_03_04.xlsx'; 
%filename = 'Result_03_04_updt.xlsx';

lab_result_table = readtable(filename, 'Sheet','Result_03_04');
lab_results = table2array(lab_result_table(:,4:10)); 

dryweight = [lab_results(1:8,4:6)-lab_results(1:8,1:3)]; % Triplicates

time_CDW = lab_results(1:8,7); 

cell_density = dryweight*1000/3; % g/L, 3 mL samples -> x g in 3mL  -> y g/L

mean_CDW = mean(cell_density,2);
std_CDW = std(cell_density,0, 2);

%% Get intended feed
intended = importdata('Values_feed_09_03_23.mat');

%% Get experimental data 
% load experimental data
% open .mat file first seperately in matlab before to see full structure
% use "clear da" and "clear data" in console for avoiding warnings
exp_data = load('20230403_MHE_None_Glucose_A2.mat', 'VarMem');

VarMem = exp_data.VarMem;
time = VarMem.ProcTime/3600;

% Substrate information
time_HPLC= VarMem.Instrument.HPLC.timeHPLC/3600;


%% Data retrieval and treatment
mu_max = system.mu_max;	 %0.27399 ;%0.30711 ; 
Ks = system.Ks; %0.0050896; %0.0070378 ;
kd =  system.kd; %0.0013298; %0.0013996 ;
Y_XS = system.Y_XS; %0.12548 ; %0.39212  ;
Y_CO2X = system.Y_CO2X; %0.28222; %0.055265; 

std_dev = system.std_dev;
 
% load experimental data
% open .mat file first seperately in matlab before to see full structure
% use "clear da" and "clear data" in console for avoiding warnings

meas    = VarMem.measurements;
ts      = time';   % [s]
Fin     = VarMem.Instrument.Flow_in';
Fout    = VarMem.Instrument.Flow_out';

t_model = ts;
%x_model = [VarMem.ModSim.V', VarMem.ModSim.X', VarMem.ModSim.S', VarMem.ModSim.CO2'];

t_tot = ts;
tF = ts;

% Update allother values
N_points        = length(ts);
Values_output   = meas(1:N_points,:);

x0= [VarMem.MHESim.V(1), VarMem.MHESim.X(1), VarMem.MHESim.S(1), VarMem.MHESim.CO2(1)]'; % Run with all data


Volume = Values_output(:,1);
X      = Values_output(:,2);
CO2    = Values_output(:,4);



% Get sugar values (datarows without NaN values)
S = sugar; %VarMem.measurements(:,3);

[row, col] = find(isnan(S));

S( row )  = [];
% Timestamp for sugar measurements
ts_S = time_s; %time_HPLC;
ts_S( row )  = [];

% Get feed usage

us = [Fin, Fout]; % [Fin]
% Save runtime !
step = 60; % experimental data was taken every 60 s system.dt;
dt = 1/60; %1/60;

runtime = zeros(length(ts),1);

%rng(1)


%% MODEL
%% Integrate system model
model = model_DYCOPS(system);

model.T    = N_points/dt;
model.dt   = dt;

x_model = zeros(N_points,4);
x_model(1, :) = x0;

% GET INTEGRATOR
model.noise = 0;
[ode_sol]    = ODE_solver(model); 
xk = x0;
t_model = zeros(N_points,1);
% Integrate model
for i= 2:N_points
    % Get previous state
    xk = [x_model(i-1,1), x_model(i-1,2), x_model(i-1,3), x_model(i-1,4)];
    
    sim = ode_sol('x0', xk, 'p', [us(i-1, :)] ); % [us(i)] ); % must check to use us(i) or us(i-1)
    
    xk_mod = full(sim.xf); % y;
    
    % Update states
    x_model(i,:)   = xk_mod;   
    t_model(i) =  t_model(i-1) + dt;
end


%% PLOT
%% Printing Paper
color = colorHex();

clf;

 set(0, 'DefaultTextFontName', 'Computer Modern',...
     'DefaultTextFontSize', 10,...
     'DefaultAxesFontName', 'Computer Modern',...
     'DefaultAxesFontSize', 10,...
     'DefaultLineLineWidth', 1.2)

set(gcf,'Position',[450 300 650 580])


tile  = tiledlayout(2,2,'TileSpacing','Compact','Padding','Compact');

x2 = [t, fliplr(t)];
inBetween_V = [Vmin, fliplr(Vmax)];
inBetween_X = [fliplr(Xmin), fliplr(Xmax)];%[Xmin, fliplr(Xmax)];
inBetween_S = [Smax, fliplr(Smin)];%[Smin, fliplr(Smax)];
inBetween_CO2 = [fliplr(CO2_min), CO2_max]; %[CO2_min, fliplr(CO2_max)];
% fill(x2, inBetween, 'Color', color.p);
%% Volume
nexttile
    hold on
    
    plot(t_model, x_model(:,1), '--','Color', 'k')
    plot(ts,      Volume,            '-.','Color', [0.5 0.5 0.5])
    %plot(t,    x_est(:,1),   '-','Color', color.b)
    plot(t,Vmin,'Color', color.b )
    plot(t,Vmax, 'Color', color.r)
    plot(t,Vmean, '-.', 'Color', color.p)
    plot(t, V_4, ':', 'Color', 'k')
    yline(1.5,'--', 'Desired')
    patch([t ; flip(t)], [Vmin ;flip(Vmax)], 'g','FaceColor', color.o, 'FaceAlpha', 0.3)

    % add axis labes and legend
    axis tight
    xlabel('Time [h]')
    ylabel('V [L]')
    %legend('boxoff')
    %legend('Model','Measurement', 'V_{min}','V_{max}','location', 'best')

%% Biomass
nexttile
    hold on
    
    plot(t_model, x_model(:,2), '--','Color', 'k')
    plot(ts,      VarMem.Instrument.CDWcu,            '-.','Color', [0.5 0.5 0.5])
    %plot(t,    x_est(:,2),   '-','Color', color.b)
    plot(time_CDW, mean_CDW, 'x', 'Color', color.r)
    %errorbar(time_CDW, mean_CDW, std_CDW, 'Color', color.p, 'LineStyle', 'none')
    plot(t,Xmin, 'Color', color.b)
    plot(t,Xmax, 'Color', color.r)
    plot(t,Xmean, '-.', 'Color', color.p)
    plot(t, X_4, ':', 'Color', 'k')
    %fill(x2, inBetween_X, 'b', 'FaceColor', color.p, 'FaceAlpha', 0.3);
    %shade(t,Xmin,t,Xmax,'FillType',[1 2;2 1]);
    patch([t ; flip(t)], [Xmin ;flip(Xmax)], 'g','FaceColor', color.o, 'FaceAlpha', 0.3)
    %a.FaceColor = color.p;
    

    % add axis labes and legend
    axis tight
    xlabel('Time [h]')
    ylabel('X [g/L]')
    legend('boxoff')
    legend('Model','Measurement', 'Offline','Min','Max', 'Avg', 'R_x=5','Variance','location', 'best')

%% Sugar
nexttile
    hold on
    
    plot(t_model, x_model(:,3), '--','Color', 'k')
    %plot(t,       x_est(:,3),   '-','Color', color.b)
    %plot(t_S, S,'x','Color', color.p)
    plot(ts_S,    S,            'x','Color', color.r)
    plot(t,Smin, 'Color', color.b)
    plot(t,Smax, 'Color', color.r)
    plot(t,Smean, '-.', 'Color', color.p)
    plot(t, S_4, ':', 'Color', 'k')
    patch([t ; flip(t)], [Smin ;flip(Smax)], 'g','FaceColor', color.o, 'FaceAlpha', 0.3)
    % add axis labes and legend
    axis tight
    xlabel('Time [h]')
    ylabel('S [g/L]')
    %legend('boxoff')
    %legend('Model','MHE','Offline','location', 'best')    %'off-line S',

%% CO2
nexttile
    hold on
    
    plot(t_model, x_model(:,4), '--','Color', 'k')
    %plot(ts,      CO2,          '-.','Color', [0.5 0.5 0.5])
    %plot(t,       x_est(:,4),   '-','Color', color.b)
    plot(t,CO2_min, 'Color', color.b)
    plot(t,CO2_max, 'Color', color.r)
    plot(t,CO2_mean, '-.', 'Color', color.p )
    plot(t, CO2_4, ':', 'Color', 'k')
    patch([t ; flip(t)], [CO2_min ;flip(CO2_max)], 'g','FaceColor', color.o, 'FaceAlpha', 0.3)
    % add axis labes and legend
    axis tight
    xlabel('Time [h]')
    ylabel('CO2 [% of gas outlet]')
    
sgtitle("MHE run 2, R")

fig = figure; clf

 set(0, 'DefaultTextFontName', 'Computer Modern',...
     'DefaultTextFontSize', 10,...
     'DefaultAxesFontName', 'Computer Modern',...
     'DefaultAxesFontSize', 10,...
     'DefaultLineLineWidth', 1.2)
 
tile  = tiledlayout(2,1,'TileSpacing','Compact','Padding','Compact');
figure(2)
nexttile
plot(t,X_max_i, 'Color', color.b)
xlabel('Time [h]')
ylabel('Index')
title('Max index for X', 'FontWeight','Normal')

nexttile
plot(t,X_min_i, 'Color', color.b)
xlabel('Time [h]')
ylabel('Index')
title('Min index for X', 'FontWeight','Normal')
sgtitle('MHE run 2, R')