%% Function
function [ode_sol] = ODE_solver(system)
    import casadi.*
    
    %% System %%
    x = system.x;   % states
    dt = system.dt;
    
    if system.noise == 1    % CHANGE
        xdot = system.xdot_n;
        u = system.u_n;   % Fin w/noise, random_0, random_1
    else
        xdot = system.xdot; % Differential equations
        u = system.u;   
    end
    %% Continuous time dynamics
    ode = struct('x',x,'p',vertcat(u),'ode',dt*xdot);

    [ode_sol] = integrator('F', 'idas', ode);
    disp(ode_sol)
end