function system = system_param()
system = struct;

%% Defining system
% Simulation time
T   = 24;     % h
dt  = 1/60;  % time step 
N   = T/dt;   % steps
 
%% Parameters %%
mu_max  = 0.2296;       % 0.19445;   % h^-1
Ks      = 0.0077556;    % 0.007;    % g L^-1
kd      = 0.0025183;    % 0.006;
Y_XS    = 0.42931;      % 0.42042; 
Y_CO2X  = 0.39387;      % 0.54308; %estimated

std_dev = [0.0001, 9.4749e-05, 4.4482e-05 , 0.0050084, 0.00010611];

Sin     = 200; %100;         % g/L
q_air   = 2;       % 2 NL/min
q_CO2   = q_air * 1.8* 60 / 100; % Density CO2: 1.8 kg/m^3, Conversion: 60 s/min, 1/100 m^3/L 
pump_speed = 0.00210; % L/h

system.T = T;            system.dt = dt;                system.N = N;
system.mu_max = mu_max;  system.Ks = Ks;                system.kd = kd;
system.Y_XS = Y_XS ;     system.Y_CO2X = Y_CO2X ;       system.std_dev = std_dev;
system.Sin  = Sin ;
system.q_CO2  = q_CO2;   system.pump_speed = pump_speed ;
end